package com.example.potatomemnap;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.res.AssetManager;
import android.graphics.Bitmap;
import android.net.Uri;
import android.os.Bundle;
import android.os.Environment;
import android.util.Log;
import android.view.Gravity;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.MotionEvent;
import android.view.View;
import android.view.ViewGroup.LayoutParams;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemSelectedListener;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.FrameLayout;
import android.widget.HorizontalScrollView;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.MediaController;
import android.widget.RadioButton;
import android.widget.RelativeLayout;
import android.widget.Spinner;
import android.widget.Toast;
import android.widget.VideoView;
//import com.googlecode.tesseract.android.TessBaseAPI;

public class GalleryActivity extends Activity {

	public static final String DATA_PATH = Environment
			.getExternalStorageDirectory().toString() + "/PotatoMemNap/";

	LinearLayout myGallery;
	ImageView selectedImageView;
	VideoView selectedVideoView;
	FrameLayout mediaViewFrame;
	MediaHandler mediaHandler;
	DBHandler dbHandler;
	boolean displayedFirstItem = false;
	RadioButton selectedRadio;

	Spinner gallerySpinner;
	Button searchDoneBtn;
	EditText searchET;
	String invalidMorningPath, invalidAfternoonPath, invalidNightPath,
			invalidLateNightPath, GPSValidPath;

	final Context context = this;

	// boolean displayingSelectedImage = true;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_gallery);
		dbHandler = new DBHandler(this.getApplicationContext());

		invalidMorningPath = Environment.getExternalStorageDirectory()
				.getAbsolutePath() + "/PotatoMemNap/GPSInvalid/Morning/";
		invalidAfternoonPath = Environment.getExternalStorageDirectory()
				.getAbsolutePath() + "/PotatoMemNap/GPSInvalid/Afternoon/";
		invalidNightPath = Environment.getExternalStorageDirectory()
				.getAbsolutePath() + "/PotatoMemNap/GPSInvalid/Night/";
		invalidLateNightPath = Environment.getExternalStorageDirectory()
				.getAbsolutePath() + "/PotatoMemNap/GPSInvalid/Late_Night/";
		GPSValidPath = Environment.getExternalStorageDirectory()
				.getAbsolutePath() + "/PotatoMemNap/GPSValid/";

		gallerySpinner = (Spinner) findViewById(R.id.sortSpinner);
		searchDoneBtn = (Button) findViewById(R.id.doneSearchBtn);
		searchET = (EditText) findViewById(R.id.searchET);

		// listener for search done button
		searchDoneBtn.setOnClickListener(new View.OnClickListener() {
			// actions to perform
			public void onClick(View v) {
				// prepOCR();
				final String searchText = searchET.getText().toString().trim();

				ArrayList<File> al = new ArrayList<File>();
				List<MediaHandler> mediaList = dbHandler.getAllMedia();
				MediaHandler curMedia = null;
				if (searchText.length() != 0) {
					// get num of medias in db
					int mediaCount = dbHandler.getMediaCount();
					Log.d("gallery act", "mediaCount = " + mediaCount);

					for (int i = 0; i < mediaCount; i++) {
						curMedia = mediaList.get(i);
						Log.d("gallery act", "checking = " + i);
						if (curMedia.getDescription().contains(searchText)) {
							File file = new File(curMedia.getFilePath());
							al.add(file);
						}
						// ///////////////OCR////////////////////////
						// Log.d("gallery act", "Before baseApi");
						//
						// TessBaseAPI baseApi = new TessBaseAPI();
						// // baseApi.setDebug(true);
						// baseApi.init(DATA_PATH, "eng");
						// //
						// baseApi.setPageSegMode(TessBaseAPI.PageSegMode.PSM_SPARSE_TEXT);
						// File curFile = new File(curMedia.getFilePath());
						// baseApi.setImage(curFile);
						//
						// Log.d("gallery act", "After baseApi");
						//
						// String recognizedText = baseApi.getUTF8Text();
						//
						// baseApi.end();
						//
						// Log.d("gallery act", "OCRED TEXT: " +
						// recognizedText);
						// ////////////END OCR/////////////////////////
					}

					if (al.isEmpty()) {
						AlertDialog.Builder alertDialogBuilder = new AlertDialog.Builder(
								context);

						// set title
						alertDialogBuilder.setTitle("Search results");

						// set dialog message
						alertDialogBuilder
								.setMessage(
										"No results found, do you want to search the Internet?")
								.setCancelable(false)
								.setPositiveButton("Yes",
										new DialogInterface.OnClickListener() {
											public void onClick(
													DialogInterface dialog,
													int id) {
												startActivity(new Intent(
														Intent.ACTION_VIEW,
														Uri.parse("http://www.google.com/search?q="
																+ searchText)));
											}
										})
								.setNegativeButton("No",
										new DialogInterface.OnClickListener() {
											public void onClick(
													DialogInterface dialog,
													int id) {
												// if this button is
												// clicked,just close the dialog
												// box and do nothing
												dialog.cancel();
											}
										});

						// create alert dialog
						AlertDialog alertDialog = alertDialogBuilder.create();

						// show alertDialog
						alertDialog.show();
					} else if (!al.isEmpty()) {
						File[] searchedFiles = new File[al.size()];
						for (int i = 0; i < al.size(); i++) {
							searchedFiles[i] = al.get(i);
						}
						load(searchedFiles);
					}
				}
			}
		});

		// Adapter for spinner
		ArrayAdapter<?> adapter = ArrayAdapter.createFromResource(
				getApplicationContext(), R.array.path_arrays,
				android.R.layout.simple_spinner_dropdown_item);
		// Sets the layout resource to create the drop down views
		adapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);

		gallerySpinner.setAdapter(adapter);

		gallerySpinner.setOnItemSelectedListener(new OnItemSelectedListener() {
			public void onItemSelected(AdapterView<?> parentView,
					View selectedItemView, int position, long id) {
				// selected item from spinner
				String item = parentView.getItemAtPosition(position).toString();

				Toast.makeText(parentView.getContext(), item, Toast.LENGTH_LONG)
						.show();

				Log.d("gallery act", "spinner = " + item);

				String targetPath = "";

				if (item.equalsIgnoreCase("Invalid-Morning")) {
					Log.d("gallery act", "loading morning = "
							+ invalidMorningPath);
					// load(invalidMorningPath);
					targetPath = invalidMorningPath;
				} else if (item.equalsIgnoreCase("Invalid-Afternooon")) {
					// load(invalidAfternoonPath);
					targetPath = invalidAfternoonPath;
				} else if (item.equalsIgnoreCase("Invalid-Night")) {
					// load(invalidNightPath);
					targetPath = invalidNightPath;
				} else if (item.equalsIgnoreCase("Invalid-LateNight")) {
					// load(invalidLateNightPath);
					targetPath = invalidLateNightPath;
				} else if (item.equalsIgnoreCase("GPSValid")) {
					// load(GPSValidPath);
					targetPath = GPSValidPath;
				}

				File targetDirector = new File(targetPath);

				File[] files = targetDirector.listFiles();
				load(files);
			}

			public void onNothingSelected(AdapterView<?> parentView) {
			}

		});
		System.gc();
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		MenuInflater inflater = getMenuInflater();
		inflater.inflate(R.menu.activity_gallery, menu);
		return true;
	}

	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		switch (item.getItemId()) {
		case R.id.gallery_display_map:
			Intent mediaDetailActivityIntent = new Intent(
					getApplicationContext(), MediaDetailActivity.class);
			mediaDetailActivityIntent.putExtra("mediaHandler",
					(Serializable) mediaHandler);
			startActivity(mediaDetailActivityIntent);
			return true;
		case R.id.gallery_exit:
			Intent intent = new Intent(Intent.ACTION_MAIN);
			intent.addCategory(Intent.CATEGORY_HOME);
			intent.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
			startActivity(intent);
			return true;
		default:
			return super.onOptionsItemSelected(item);
		}
	}

	public void prepOCR() {
		File OCRPath = new File(DATA_PATH + "tessdata/");
		if (!OCRPath.exists()) {
			OCRPath.mkdirs();
		}

		if (!(new File(DATA_PATH + "tessdata/" + "eng.traineddata")).exists()) {
			try {

				AssetManager assetManager = getAssets();
				InputStream in = assetManager.open("tessdata/eng.traineddata");
				// GZIPInputStream gin = new GZIPInputStream(in);
				OutputStream out = new FileOutputStream(DATA_PATH
						+ "tessdata/eng.traineddata");

				// Transfer bytes from in to out
				byte[] buf = new byte[1024];
				int len;
				// while ((lenf = gin.read(buff)) > 0) {
				while ((len = in.read(buf)) > 0) {
					out.write(buf, 0, len);
				}
				in.close();
				// gin.close();
				out.close();

				Log.v("Gallert act", "Copied " + "eng" + " traineddata");
			} catch (IOException e) {
				Log.e("Gallert act", "Was unable to copy " + "eng"
						+ " traineddata " + e.toString());
			}
		}
	}

	public void load(File[] files) {
		selectedVideoView = new VideoView(this.getApplicationContext());
		selectedImageView = new ImageView(this.getApplicationContext());
		mediaViewFrame = (FrameLayout) findViewById(R.id.frameMediaView);
		myGallery = (LinearLayout) findViewById(R.id.mygallery);

		// final RadioButton invalidMorningButton = (RadioButton)
		// findViewById(R.id.invalidMorningButton);
		// final RadioButton invalidAfternoonButton = (RadioButton)
		// findViewById(R.id.invalidAfternoonButton);
		// final RadioButton invalidNightButton = (RadioButton)
		// findViewById(R.id.invalidNightButton);
		// final RadioButton invalidLateNightButton = (RadioButton)
		// findViewById(R.id.invalidLateNightButton);
		// final RadioButton GPSValidButton = (RadioButton)
		// findViewById(R.id.GPSValidButton);
		HorizontalScrollView hsv = (HorizontalScrollView) findViewById(R.id.horizontalScrollView1);

		// set up initial target path n radio buttons
		// if (targetPath.equalsIgnoreCase("")) {
		// targetPath = invalidMorningPath;
		// invalidMorningButton.setChecked(true);
		// } else if (targetPath.equalsIgnoreCase(invalidMorningPath)) {
		// invalidMorningButton.setChecked(true);
		// } else if (targetPath.equalsIgnoreCase(invalidAfternoonPath)) {
		// invalidAfternoonButton.setChecked(true);
		// } else if (targetPath.equalsIgnoreCase(invalidNightPath)) {
		// invalidNightButton.setChecked(true);
		// } else if (targetPath.equalsIgnoreCase(invalidLateNightPath)) {
		// invalidLateNightButton.setChecked(true);
		// } else if (targetPath.equalsIgnoreCase(GPSValidPath)) {
		// GPSValidButton.setChecked(true);
		// }

		// File targetDirector = new File(targetPath);

		// File[] files = targetDirector.listFiles();

		if (files.length > 0) {
			for (File file : files) {
				Log.d("gallery act", "add view to = " + file.getAbsolutePath());
				myGallery.addView(insertMedia(file.getAbsolutePath()));
			}
		} else {
			// mediaViewFrame.removeAllViews();
			// hsv.setVisibility(View.GONE);
			Toast.makeText(getApplicationContext(), "No images available",
					Toast.LENGTH_LONG).show();
		}

		// // listener for invalidMorningButton button
		// invalidMorningButton.setOnClickListener(new View.OnClickListener() {
		// // actions to perform
		// public void onClick(View v) {
		// load(invalidMorningPath);
		// }
		// });
		//
		// // listener for invalidAfternoonButton button
		// invalidAfternoonButton.setOnClickListener(new View.OnClickListener()
		// {
		// // actions to perform
		// public void onClick(View v) {
		// load(invalidAfternoonPath);
		// }
		// });
		//
		// // listener for invalidNightButton button
		// invalidNightButton.setOnClickListener(new View.OnClickListener() {
		// // actions to perform
		// public void onClick(View v) {
		// load(invalidNightPath);
		// }
		// });
		//
		// // listener for invalidLateNightButton button
		// invalidLateNightButton.setOnClickListener(new View.OnClickListener()
		// {
		// // actions to perform
		// public void onClick(View v) {
		// load(invalidLateNightPath);
		// }
		// });
		//
		// // listener for GPSValidButton button
		// GPSValidButton.setOnClickListener(new View.OnClickListener() {
		// // actions to perform
		// public void onClick(View v) {
		// load(GPSValidPath);
		// }
		// });
	}

	public View insertMedia(final String path) {
		mediaHandler = dbHandler.getMediaInfo(path);

		// get the mediaType
		// String mediaType = path.substring(path.indexOf(".") + 1);
		int mediaType = mediaHandler.getMediaType(path);
		final int rotate = mediaHandler.correctOrientation(
				this.getApplicationContext(), mediaHandler);

		// get the relativelayout to add the selected image/videoview
		// final RelativeLayout rl = (RelativeLayout)
		// findViewById(R.id.relativeLayout1);
		// final RelativeLayout.LayoutParams rlParams = new
		// RelativeLayout.LayoutParams(
		// LayoutParams.WRAP_CONTENT, LayoutParams.WRAP_CONTENT);
		// rlParams.addRule(RelativeLayout.ABOVE, R.id.horizontalScrollView1);
		// rlParams.addRule(RelativeLayout.BELOW, R.id.radioRelativeLayout);
		// rlParams.addRule(RelativeLayout.ALIGN_PARENT_TOP);
		// rlParams.addRule(RelativeLayout.ALIGN_PARENT_LEFT);
		// rlParams.addRule(RelativeLayout.ALIGN_PARENT_RIGHT);

		final RelativeLayout.LayoutParams params = new RelativeLayout.LayoutParams(
				LayoutParams.WRAP_CONTENT, LayoutParams.WRAP_CONTENT);
		params.addRule(RelativeLayout.CENTER_IN_PARENT);
		params.addRule(RelativeLayout.ALIGN_PARENT_LEFT);
		params.addRule(RelativeLayout.ALIGN_PARENT_RIGHT);
		params.addRule(RelativeLayout.ALIGN_PARENT_TOP);
		params.addRule(RelativeLayout.ALIGN_PARENT_BOTTOM);

		FrameLayout.LayoutParams flParams = new FrameLayout.LayoutParams(
				LayoutParams.MATCH_PARENT, LayoutParams.MATCH_PARENT);

		// create a linearlayout for each of the image/video view on the
		// horizontalscrollview
		LinearLayout layout = new LinearLayout(getApplicationContext());
		layout.setLayoutParams(new LayoutParams(120, 120));
		layout.setGravity(Gravity.CENTER);

		Bitmap bm = mediaHandler.decodeSampledBitmapFromUri(path, 100, 100);
		// imageview on horizontalscrollview
		ImageView imageView = new ImageView(getApplicationContext());
		imageView.setLayoutParams(new LayoutParams(100, 100));
		imageView.setScaleType(ImageView.ScaleType.CENTER_CROP);
		imageView.setRotation(rotate);
		imageView.setImageBitmap(bm);
		layout.addView(imageView);

		if (mediaType == MediaHandler.IMAGE) {
			// set the initial selected image/videoview to first item
			if (displayedFirstItem == false) {
				Bitmap selectedBitmap = mediaHandler
						.decodeSampledBitmapFromUri(mediaHandler.getFilePath(),
								800, 600);
				// int rotate = mediaHandler.correctOrientation();
				selectedImageView.setRotation(rotate);
				selectedImageView.setScaleType(ImageView.ScaleType.FIT_CENTER);
				selectedImageView.setImageBitmap(selectedBitmap);
				mediaViewFrame.addView(selectedImageView);
				displayedFirstItem = true;
			}

			// listener for the each of the imageview on the
			// horizontalscrollview
			imageView.setOnTouchListener(new View.OnTouchListener() {
				public boolean onTouch(View v, MotionEvent event) {
					mediaViewFrame.removeAllViews();
					mediaViewFrame.addView(selectedImageView);

					Bitmap selectedBitmap = mediaHandler
							.decodeSampledBitmapFromUri(path, 800, 600);
					// int rotate = mediaHandler.correctOrientation();
					selectedImageView.setRotation(rotate);
					selectedImageView
							.setScaleType(ImageView.ScaleType.FIT_CENTER);
					selectedImageView.setImageBitmap(selectedBitmap);

					mediaHandler = dbHandler.getMediaInfo(path);
					return false;
				}
			});
		} else {
			// set the initial selected image/videoview to first item
			if (displayedFirstItem == false) {
				selectedVideoView.setVideoPath(path);
				selectedVideoView.setMediaController(new MediaController(this));
				selectedVideoView.requestFocus();
				mediaViewFrame.addView(selectedVideoView);
				displayedFirstItem = true;
			}

			// videoview on horizontalscrollview
			VideoView videoView = new VideoView(this);
			videoView.setLayoutParams(new LayoutParams(100, 100));
			videoView.setVideoPath(path);
			// videoView.setRotation(rotate);
			layout.addView(videoView);

			// listener for the each of the videoview on the
			// horizontalscrollview
			videoView.setOnTouchListener(new View.OnTouchListener() {
				public boolean onTouch(View v, MotionEvent event) {
					selectedVideoView.setVideoPath(path);
					selectedVideoView.requestFocus();
					mediaHandler = dbHandler.getMediaInfo(path);
					mediaViewFrame.removeAllViews();
					mediaViewFrame.addView(selectedVideoView, params);
					return false;
				}
			});
			selectedVideoView.setMediaController(new MediaController(this));
		}
		return layout;
	}

	@Override
	protected void onPause() {
		super.onPause();
		Log.d("gallery pausing", "pausing");

		if (dbHandler != null) {
			dbHandler.close();
		}

		if (mediaHandler != null) {
			mediaHandler = null;
		}
		// finish();
	}

	@Override
	protected void onResume() {
		super.onResume();
		Log.d("gallery resuming", "resuming");
		// load("");
	}

	protected void onDestroy() {
		super.onDestroy();
		Log.d("gallery destroying", "destroying");
	}

}