package com.example.potatomemnap;

import java.io.IOException;
import java.util.List;
import java.util.Locale;

import android.annotation.SuppressLint;
import android.app.Activity;
import android.content.Intent;
import android.location.Address;
import android.location.Geocoder;
import android.os.Bundle;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.webkit.WebView;
import android.widget.TextView;

@SuppressLint("SetJavaScriptEnabled")
public class MediaDetailActivity extends Activity {

	MediaHandler mediaHandler;
	WebView position;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		System.gc();

	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		getMenuInflater().inflate(R.menu.activity_media_detail, menu);
		return true;
	}

	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		switch (item.getItemId()) {
		case R.id.detail_exit:
			Intent intent = new Intent(Intent.ACTION_MAIN);
			intent.addCategory(Intent.CATEGORY_HOME);
			intent.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
			startActivity(intent);
			return true;
		default:
			return super.onOptionsItemSelected(item);
		}
	}

	public void load() {
		setContentView(R.layout.activity_media_detail);

		Bundle extras = this.getIntent().getExtras();

		if (extras != null) {
			this.mediaHandler = (MediaHandler) extras
					.getSerializable("mediaHandler");
		}

		TextView mediaNameTV = (TextView) findViewById(R.id.mediaDetail_mediaNameTV);
		TextView mediaLocNameTV = (TextView) findViewById(R.id.mediaDetail_mediaLocationTV);
		TextView mediaDescTV = (TextView) findViewById(R.id.mediaDetail_mediaDescTV);

		mediaNameTV.setText("Name: "
				+ mediaHandler.getFilePath());

		mediaDescTV.setText("Description: " + mediaHandler.getDescription());

		if (mediaHandler.getLat() != -1 && mediaHandler.getLng() != -1) {
			Geocoder geocoder = new Geocoder(this.getApplicationContext(),
					Locale.ENGLISH);
			StringBuilder strReturnedAddress = null;

			try {
				List<Address> addresses = geocoder.getFromLocation(
						mediaHandler.getLat(), mediaHandler.getLng(), 1);

				if (addresses != null) {
					Address returnedAddress = addresses.get(0);
					strReturnedAddress = new StringBuilder("Address:\n");

					for (int i = 0; i < returnedAddress
							.getMaxAddressLineIndex(); i++) {
						strReturnedAddress.append(
								returnedAddress.getAddressLine(i)).append("\n");
					}
				}
			} catch (IOException e) {
				e.printStackTrace();
			}

			position = (WebView) findViewById(R.id.mediaDetailWebView);
			position.getSettings().setJavaScriptEnabled(true);

			String url = "http://maps.google.com/staticmap?center="
					+ mediaHandler.getLat() + "," + mediaHandler.getLng()
					+ "&zoom=18&size=512x512&map/&markers="
					+ mediaHandler.getLat() + "," + mediaHandler.getLng();
			// load the URL
			position.loadUrl(url);
			mediaLocNameTV
					.setText("Location: " + strReturnedAddress.toString());
		} else {
			mediaLocNameTV.setText("Location not available");
		}
	}

	@Override
	protected void onPause() {
		super.onPause();
		Log.d("mediaDetail pausing", "pausing");

		if (mediaHandler != null) {
			mediaHandler = null;
		}

		if (position != null) {
			position = null;
		}
		//finish();
	}

	@Override
	protected void onResume() {
		super.onResume();
		Log.d("mediaDetail resuming", "resuming");
		load();
	}

	protected void onDestroy() {
		super.onDestroy();
		Log.d("media_detail destroying", "destroying");
	}
}
