package com.example.potatomemnap;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;

public class MenuActivity extends Activity {

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		System.gc();

	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		getMenuInflater().inflate(R.menu.activity_menu, menu);
		return true;
	}

	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		switch (item.getItemId()) {
		case R.id.menu_exit:
			Intent intent = new Intent(Intent.ACTION_MAIN);
			intent.addCategory(Intent.CATEGORY_HOME);
			intent.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
			System.gc();
			startActivity(intent);
			return true;
		default:
			return super.onOptionsItemSelected(item);
		}
	}

	public void load() {
		setContentView(R.layout.activity_menu);

		// listener for media(cam/vid) toggle
		findViewById(R.id.startCamActBtn).setOnClickListener(
				new View.OnClickListener() {
					// actions to perform
					public void onClick(View v) {
						Intent camIntent = new Intent(getApplicationContext(),
								CameraActivity.class);
						startActivity(camIntent);
					}
				});

		// listener for media(cam/vid) toggle
		findViewById(R.id.startVidActBtn).setOnClickListener(
				new View.OnClickListener() {
					// actions to perform
					public void onClick(View v) {
						Intent videoIntent = new Intent(
								getApplicationContext(), VideoActivity.class);
						startActivity(videoIntent);
					}
				});

		// listener for media(cam/vid) toggle
		findViewById(R.id.startGalleryBtn).setOnClickListener(
				new View.OnClickListener() {
					// actions to perform
					public void onClick(View v) {
						Intent galleryIntent = new Intent(
								getApplicationContext(), GalleryActivity.class);
						startActivity(galleryIntent);

					}
				});
	}

	@Override
	protected void onPause() {
		super.onPause();
		Log.d("menu pausing", "pausing");
	}

	@Override
	protected void onResume() {
		super.onResume();
		Log.d("menu resuming", "resuming");
		load();
	}

	protected void onDestroy() {
		super.onDestroy();
		Log.d("menu destroying", "destroying");
	}
}
