package com.example.potatomemnap;

import java.io.File;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.graphics.Bitmap;
import android.os.Bundle;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.inputmethod.InputMethodManager;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.MediaController;
import android.widget.TextView;
import android.widget.Toast;
import android.widget.VideoView;

public class SavedMediaActivity extends Activity {

	DBHandler dbhandler;
	MediaHandler mediaHandler;
	Button addDescBtn, discardBtn, favLocBtn;
	String mediaFile;
	ImageView myImage;

	TextView favLocTV = null;
	EditText favLocET = null;
	Button favLocDoneBtn = null;

	TextView renameTV = null;
	EditText renameET = null;
	Button renameDoneBtn = null;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		dbhandler = new DBHandler(this.getApplicationContext());

		Bundle extras = this.getIntent().getExtras();

		if (extras != null) {
			this.mediaHandler = (MediaHandler) extras
					.getSerializable("mediaHandler");
			this.mediaFile = extras.getString("mediaFile");
		}

		// String mediaType = mediaFile.substring(mediaFile.indexOf(".") + 1);
		int mediaType = mediaHandler.getMediaType(mediaFile);

		// get the correct rotation to display
		int rotate = mediaHandler.correctOrientation(
				this.getApplicationContext(), mediaHandler);
		Log.d("savedMedia", "rotate  = " + rotate);

		discardBtn = (Button) findViewById(R.id.discardBtn);
		favLocBtn = (Button) findViewById(R.id.favLocBtn);

		if (mediaType == MediaHandler.IMAGE) {
			setContentView(R.layout.activity_saved_image);

			ImageView myImage = (ImageView) findViewById(R.id.imageView);

			Bitmap bm = mediaHandler.decodeSampledBitmapFromUri(
					mediaHandler.getFilePath(), 800, 600);
			// myImage.setBackgroundColor(Color.BLACK);
			myImage.setScaleType(ImageView.ScaleType.FIT_CENTER);
			myImage.setRotation(rotate);
			myImage.setImageBitmap(bm);
		} else {
			setContentView(R.layout.activity_saved_video);
			VideoView videoView = (VideoView) findViewById(R.id.vidVideoView);
			videoView.setVideoPath(mediaFile);
			videoView.setMediaController(new MediaController(this));
			videoView.requestFocus();
		}

		// listener for discard image button
		findViewById(R.id.discardBtn).setOnClickListener(
				new View.OnClickListener() {
					// actions to perform
					public void onClick(View v) {
						discardImage(mediaFile);
						Log.d("image count after del",
								"count = " + dbhandler.getMediaCount());
						dbhandler.close();
						Intent menuIntent = new Intent(getApplicationContext(),
								MenuActivity.class);
						startActivity(menuIntent);
					}
				});

		// listener for favourite location button
		findViewById(R.id.favLocBtn).setOnClickListener(
				new View.OnClickListener() {
					// actions to perform
					public void onClick(View v) {
						if (mediaHandler.getLat() != 1
								&& mediaHandler.getLng() != -1) {

							favLocTV = (TextView) findViewById(R.id.favLocTV);
							favLocET = (EditText) findViewById(R.id.favLocET);
							favLocDoneBtn = (Button) findViewById(R.id.favLocDoneBtn);

							renameTV = (TextView) findViewById(R.id.renameTV);
							renameET = (EditText) findViewById(R.id.renameET);
							renameDoneBtn = (Button) findViewById(R.id.renameDoneBtn);

							if (renameTV.isShown()) {
								renameTV.setVisibility(View.INVISIBLE);
								renameET.setVisibility(View.INVISIBLE);
								renameDoneBtn.setVisibility(View.INVISIBLE);
							}

							favLocTV.setVisibility(View.VISIBLE);
							favLocET.setVisibility(View.VISIBLE);
							favLocDoneBtn.setVisibility(View.VISIBLE);

							// listener for done description button
							favLocDoneBtn
									.setOnClickListener(new View.OnClickListener() {
										// actions to perform
										public void onClick(View v) {
											String favLocETText = favLocET
													.getText().toString()
													.trim();
											if (favLocETText.length() != 0) {
												mediaHandler
														.setFavLocName(favLocETText);
												mediaHandler
														.setIsFav(MediaHandler.IS_FAV);
												dbhandler
														.updateMediaFav(mediaHandler);
												dbhandler
														.updateMediaFavLocName(mediaHandler);

												// String[] curMediaStoreDesc =
												// mediaHandler
												// .getDescriptionFromMediaStore(
												// getApplicationContext(),
												// mediaHandler
												// .getFilePath());
												//
												// String[] tokenMediaStoreDesc
												// = curMediaStoreDesc[1]
												// .split("|");
												//
												// String updateMediaStoreDesc =
												// mediaHandler
												// .getIsFav()
												// + "|"
												// + favLocETText
												// + "|"
												// + tokenMediaStoreDesc[2];
												//
												// Log.d("savedMedia",
												// "toBeUpdate = "
												// + updateMediaStoreDesc);
												//
												// mediaHandler
												// .updateDescFromMediaStore(
												// getApplicationContext(),
												// curMediaStoreDesc[0],
												// updateMediaStoreDesc,
												// mediaHandler
												// .getFilePath());
												// hide virtual keyboard after
												// input favLocName
												InputMethodManager imm = (InputMethodManager) getSystemService(Context.INPUT_METHOD_SERVICE);
												imm.hideSoftInputFromWindow(
														favLocET.getWindowToken(),
														0);

												Toast.makeText(
														getApplicationContext(),
														"Location added: "
																+ mediaHandler
																		.getFavLocName(),
														Toast.LENGTH_SHORT)
														.show();
												Log.d("in saved media",
														"locName = "
																+ mediaHandler
																		.getFavLocName());
												dbhandler.close();
											}
										}
									});
						} else {
							Toast.makeText(getApplicationContext(),
									"GPS is not valid", Toast.LENGTH_SHORT)
									.show();
							Log.d("fav loc added",
									"fav cannot be added in saved_media: "
											+ mediaHandler.getIsFav());
						}
					}
				});

		// listener for favourite location button
		findViewById(R.id.renameBtn).setOnClickListener(
				new View.OnClickListener() {
					// actions to perform
					public void onClick(View v) {

						favLocTV = (TextView) findViewById(R.id.favLocTV);
						favLocET = (EditText) findViewById(R.id.favLocET);
						favLocDoneBtn = (Button) findViewById(R.id.favLocDoneBtn);

						renameTV = (TextView) findViewById(R.id.renameTV);
						renameET = (EditText) findViewById(R.id.renameET);
						renameDoneBtn = (Button) findViewById(R.id.renameDoneBtn);

						if (favLocTV.isShown()) {
							favLocTV.setVisibility(View.INVISIBLE);
							favLocET.setVisibility(View.INVISIBLE);
							favLocDoneBtn.setVisibility(View.INVISIBLE);
						}

						renameTV.setVisibility(View.VISIBLE);
						renameET.setVisibility(View.VISIBLE);
						renameDoneBtn.setVisibility(View.VISIBLE);

						// listener for done description button
						renameDoneBtn
								.setOnClickListener(new View.OnClickListener() {
									// actions to perform
									public void onClick(View v) {
										String renameETText = renameET
												.getText().toString().trim();
										if (renameETText.length() != 0) {
											String curName = mediaHandler
													.getFilePath();
											String directory = "";
											String newName = "";
											if (mediaHandler
													.getMediaType(mediaHandler
															.getFilePath()) == MediaHandler.IMAGE) {
												directory = curName.substring(
														0,
														curName.indexOf("Picture_"));

												newName = directory
														+ "Picture_"
														+ renameETText + ".jpg";
											} else {
												directory = curName.substring(
														0,
														curName.indexOf("Video"));

												newName = directory + "Video_"
														+ renameETText + ".mp4";
											}

											Log.d("savedMedia", "affix = "
													+ directory);

											Log.d("savedMedia", "new name = "
													+ newName);

											File from = new File(curName);
											File to = new File(newName);
											from.renameTo(to);

											mediaHandler.triggerMediaScanner(
													newName,
													getApplicationContext());

											mediaHandler.setFilePath(newName);

											dbhandler.updateMediaPath(
													mediaHandler, curName);

											InputMethodManager imm = (InputMethodManager) getSystemService(Context.INPUT_METHOD_SERVICE);
											imm.hideSoftInputFromWindow(
													renameET.getWindowToken(),
													0);

											Toast.makeText(
													getApplicationContext(),
													"Renamed to: "
															+ mediaHandler
																	.getFilePath(),
													Toast.LENGTH_SHORT).show();
											Log.d("in saved media",
													"Renamed to = "
															+ mediaHandler
																	.getFilePath());
											dbhandler.close();
										}
									}
								});
					}
				});

		// listener for start menu button
		findViewById(R.id.startMenuBtn).setOnClickListener(
				new View.OnClickListener() {
					// actions to perform
					public void onClick(View v) {
						dbhandler.close();
						Intent menuIntent = new Intent(getApplicationContext(),
								MenuActivity.class);
						startActivity(menuIntent);
					}
				});

		final EditText descET = (EditText) findViewById(R.id.descET);

		// listener for done description button
		findViewById(R.id.descDoneBtn).setOnClickListener(
				new View.OnClickListener() {
					// actions to perform
					public void onClick(View v) {
						mediaHandler
								.setDescription(descET.getText().toString());
						Log.d("edittext value", descET.getText().toString());
						// save description to database
						dbhandler.updateMediaDesc(mediaHandler);
						// hide the virtual keyboard after input desc
						InputMethodManager imm = (InputMethodManager) getSystemService(Context.INPUT_METHOD_SERVICE);
						imm.hideSoftInputFromWindow(descET.getWindowToken(), 0);

						Toast.makeText(getApplicationContext(),
								"Description saved", Toast.LENGTH_SHORT).show();
						Log.d("desc",
								"desc saved: " + mediaHandler.getDescription());

						// can be deleted
						MediaHandler dbImage = dbhandler
								.getMediaInfo(mediaHandler.getFilePath());

						Log.d("db info after update desc",
								"path = " + dbImage.getFilePath() + " lat = "
										+ dbImage.getLat() + " lng = "
										+ dbImage.getLng() + " desc = "
										+ dbImage.getDescription() + "isfav = "
										+ dbImage.getIsFav());
					}
				});

	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		getMenuInflater().inflate(R.menu.activity_media_preview, menu);
		return true;
	}

	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		switch (item.getItemId()) {
		case R.id.saved_media_exit:
			Intent intent = new Intent(Intent.ACTION_MAIN);
			intent.addCategory(Intent.CATEGORY_HOME);
			intent.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
			System.gc();
			startActivity(intent);
			return true;
		default:
			return super.onOptionsItemSelected(item);
		}
	}

	// public void load() {
	// dbhandler = new DBHandler(this.getApplicationContext());
	//
	// Bundle extras = this.getIntent().getExtras();
	//
	// if (extras != null) {
	// this.mediaHandler = (MediaHandler) extras
	// .getSerializable("mediaHandler");
	// this.mediaFile = extras.getString("mediaFile");
	// }
	//
	// // String mediaType = mediaFile.substring(mediaFile.indexOf(".") + 1);
	// int mediaType = mediaHandler.getMediaType(mediaFile);
	//
	// // get the correct rotation to display
	// int rotate = mediaHandler.correctOrientation(
	// this.getApplicationContext(), mediaHandler);
	// Log.d("savedMedia", "rotate  = " + rotate);
	//
	// discardBtn = (Button) findViewById(R.id.discardBtn);
	// favLocBtn = (Button) findViewById(R.id.favLocBtn);
	//
	// if (mediaType == MediaHandler.IMAGE) {
	// setContentView(R.layout.activity_saved_image);
	//
	// ImageView myImage = (ImageView) findViewById(R.id.imageView);
	//
	// Bitmap bm = mediaHandler.decodeSampledBitmapFromUri(
	// mediaHandler.getFilePath(), 800, 600);
	// // myImage.setBackgroundColor(Color.BLACK);
	// myImage.setScaleType(ImageView.ScaleType.FIT_CENTER);
	// myImage.setRotation(rotate);
	// myImage.setImageBitmap(bm);
	// } else {
	// setContentView(R.layout.activity_saved_video);
	// VideoView videoView = (VideoView) findViewById(R.id.vidVideoView);
	// videoView.setVideoPath(mediaFile);
	// videoView.setMediaController(new MediaController(this));
	// videoView.requestFocus();
	// }
	//
	// // listener for discard image button
	// findViewById(R.id.discardBtn).setOnClickListener(
	// new View.OnClickListener() {
	// // actions to perform
	// public void onClick(View v) {
	// discardImage(mediaFile);
	// Log.d("image count after del",
	// "count = " + dbhandler.getMediaCount());
	// dbhandler.close();
	// Intent menuIntent = new Intent(getApplicationContext(),
	// MenuActivity.class);
	// startActivity(menuIntent);
	// }
	// });
	//
	// // listener for favourite location button
	// findViewById(R.id.favLocBtn).setOnClickListener(
	// new View.OnClickListener() {
	// // actions to perform
	// public void onClick(View v) {
	// if (mediaHandler.getLat() != 1
	// && mediaHandler.getLng() != -1) {
	//
	// favLocTV = (TextView) findViewById(R.id.favLocTV);
	// favLocET = (EditText) findViewById(R.id.favLocET);
	// favLocDoneBtn = (Button) findViewById(R.id.favLocDoneBtn);
	//
	// renameTV = (TextView) findViewById(R.id.renameTV);
	// renameET = (EditText) findViewById(R.id.renameET);
	// renameDoneBtn = (Button) findViewById(R.id.renameDoneBtn);
	//
	// if (renameTV.isShown()) {
	// renameTV.setVisibility(View.INVISIBLE);
	// renameET.setVisibility(View.INVISIBLE);
	// renameDoneBtn.setVisibility(View.INVISIBLE);
	// }
	//
	// favLocTV.setVisibility(View.VISIBLE);
	// favLocET.setVisibility(View.VISIBLE);
	// favLocDoneBtn.setVisibility(View.VISIBLE);
	//
	// // listener for done description button
	// favLocDoneBtn
	// .setOnClickListener(new View.OnClickListener() {
	// // actions to perform
	// public void onClick(View v) {
	// String favLocETText = favLocET
	// .getText().toString()
	// .trim();
	// if (favLocETText.length() != 0) {
	// mediaHandler
	// .setFavLocName(favLocETText);
	// mediaHandler
	// .setIsFav(MediaHandler.IS_FAV);
	// dbhandler
	// .updateMediaFav(mediaHandler);
	// dbhandler
	// .updateMediaFavLocName(mediaHandler);
	//
	// // String[] curMediaStoreDesc =
	// // mediaHandler
	// // .getDescriptionFromMediaStore(
	// // getApplicationContext(),
	// // mediaHandler
	// // .getFilePath());
	// //
	// // String[] tokenMediaStoreDesc
	// // = curMediaStoreDesc[1]
	// // .split("|");
	// //
	// // String updateMediaStoreDesc =
	// // mediaHandler
	// // .getIsFav()
	// // + "|"
	// // + favLocETText
	// // + "|"
	// // + tokenMediaStoreDesc[2];
	// //
	// // Log.d("savedMedia",
	// // "toBeUpdate = "
	// // + updateMediaStoreDesc);
	// //
	// // mediaHandler
	// // .updateDescFromMediaStore(
	// // getApplicationContext(),
	// // curMediaStoreDesc[0],
	// // updateMediaStoreDesc,
	// // mediaHandler
	// // .getFilePath());
	// // hide virtual keyboard after
	// // input favLocName
	// InputMethodManager imm = (InputMethodManager)
	// getSystemService(Context.INPUT_METHOD_SERVICE);
	// imm.hideSoftInputFromWindow(
	// favLocET.getWindowToken(),
	// 0);
	//
	// Toast.makeText(
	// getApplicationContext(),
	// "Location added: "
	// + mediaHandler
	// .getFavLocName(),
	// Toast.LENGTH_SHORT)
	// .show();
	// Log.d("in saved media",
	// "locName = "
	// + mediaHandler
	// .getFavLocName());
	// dbhandler.close();
	// }
	// }
	// });
	// } else {
	// Toast.makeText(getApplicationContext(),
	// "GPS is not valid", Toast.LENGTH_SHORT)
	// .show();
	// Log.d("fav loc added",
	// "fav cannot be added in saved_media: "
	// + mediaHandler.getIsFav());
	// }
	// }
	// });
	//
	// // listener for favourite location button
	// findViewById(R.id.renameBtn).setOnClickListener(
	// new View.OnClickListener() {
	// // actions to perform
	// public void onClick(View v) {
	//
	// favLocTV = (TextView) findViewById(R.id.favLocTV);
	// favLocET = (EditText) findViewById(R.id.favLocET);
	// favLocDoneBtn = (Button) findViewById(R.id.favLocDoneBtn);
	//
	// renameTV = (TextView) findViewById(R.id.renameTV);
	// renameET = (EditText) findViewById(R.id.renameET);
	// renameDoneBtn = (Button) findViewById(R.id.renameDoneBtn);
	//
	// if (favLocTV.isShown()) {
	// favLocTV.setVisibility(View.INVISIBLE);
	// favLocET.setVisibility(View.INVISIBLE);
	// favLocDoneBtn.setVisibility(View.INVISIBLE);
	// }
	//
	// renameTV.setVisibility(View.VISIBLE);
	// renameET.setVisibility(View.VISIBLE);
	// renameDoneBtn.setVisibility(View.VISIBLE);
	//
	// // listener for done description button
	// renameDoneBtn
	// .setOnClickListener(new View.OnClickListener() {
	// // actions to perform
	// public void onClick(View v) {
	// String renameETText = renameET
	// .getText().toString().trim();
	// if (renameETText.length() != 0) {
	// String curName = mediaHandler
	// .getFilePath();
	// String directory = "";
	// String newName = "";
	// if (mediaHandler
	// .getMediaType(mediaHandler
	// .getFilePath()) == MediaHandler.IMAGE) {
	// directory = curName.substring(
	// 0,
	// curName.indexOf("Picture_"));
	//
	// newName = directory
	// + "Picture_"
	// + renameETText + ".jpg";
	// } else {
	// directory = curName.substring(
	// 0,
	// curName.indexOf("Video"));
	//
	// newName = directory + "Video"
	// + renameETText + ".mp4";
	// }
	//
	// Log.d("savedMedia", "affix = "
	// + directory);
	//
	// Log.d("savedMedia", "new name = "
	// + newName);
	//
	// File from = new File(curName);
	// File to = new File(newName);
	// from.renameTo(to);
	//
	// mediaHandler.triggerMediaScanner(
	// newName,
	// getApplicationContext());
	//
	// mediaHandler.setFilePath(newName);
	//
	// dbhandler.updateMediaPath(
	// mediaHandler, curName);
	//
	// InputMethodManager imm = (InputMethodManager)
	// getSystemService(Context.INPUT_METHOD_SERVICE);
	// imm.hideSoftInputFromWindow(
	// renameET.getWindowToken(),
	// 0);
	//
	// Toast.makeText(
	// getApplicationContext(),
	// "Renamed to: "
	// + mediaHandler
	// .getFilePath(),
	// Toast.LENGTH_SHORT).show();
	// Log.d("in saved media",
	// "Renamed to = "
	// + mediaHandler
	// .getFilePath());
	// dbhandler.close();
	// }
	// }
	// });
	// }
	// });
	//
	// // listener for start menu button
	// findViewById(R.id.startMenuBtn).setOnClickListener(
	// new View.OnClickListener() {
	// // actions to perform
	// public void onClick(View v) {
	// dbhandler.close();
	// Intent menuIntent = new Intent(getApplicationContext(),
	// MenuActivity.class);
	// startActivity(menuIntent);
	// }
	// });
	//
	// final EditText descET = (EditText) findViewById(R.id.descET);
	//
	// // listener for done description button
	// findViewById(R.id.descDoneBtn).setOnClickListener(
	// new View.OnClickListener() {
	// // actions to perform
	// public void onClick(View v) {
	// mediaHandler
	// .setDescription(descET.getText().toString());
	// Log.d("edittext value", descET.getText().toString());
	// // save description to database
	// dbhandler.updateMediaDesc(mediaHandler);
	// // hide the virtual keyboard after input desc
	// InputMethodManager imm = (InputMethodManager)
	// getSystemService(Context.INPUT_METHOD_SERVICE);
	// imm.hideSoftInputFromWindow(descET.getWindowToken(), 0);
	//
	// Toast.makeText(getApplicationContext(),
	// "Description saved", Toast.LENGTH_SHORT).show();
	// Log.d("desc",
	// "desc saved: " + mediaHandler.getDescription());
	//
	// // can be deleted
	// MediaHandler dbImage = dbhandler
	// .getMediaInfo(mediaHandler.getFilePath());
	//
	// Log.d("db info after update desc",
	// "path = " + dbImage.getFilePath() + " lat = "
	// + dbImage.getLat() + " lng = "
	// + dbImage.getLng() + " desc = "
	// + dbImage.getDescription() + "isfav = "
	// + dbImage.getIsFav());
	// }
	// });
	// }
	//
	public void discardImage(String path) {
		File delFile = new File(path);
		// delete file from file system
		boolean fileDeleted = delFile.delete();
		// delete file from DB
		dbhandler.deleteMedia(mediaHandler);
		// Inform user
		if (fileDeleted == true) {
			Toast.makeText(getApplicationContext(), "File deleted",
					Toast.LENGTH_SHORT).show();
			Log.d("delete file", "deleted");
		} else {
			Toast.makeText(getApplicationContext(), "Fail to delete",
					Toast.LENGTH_SHORT).show();
			Log.d("delete file", "failed");
		}
	}

	@Override
	protected void onPause() {
		super.onPause();
		if (dbhandler != null) {
			dbhandler.close();
			dbhandler = null;
		}

		if (mediaHandler != null) {
			mediaHandler = null;
		}
		Log.d("savedmediaactivity pausing", "pausinging");
		// finish();
	}

	@Override
	protected void onResume() {
		super.onResume();
		Log.d("savedmediaactivity pausing", "pausing");
		// load();
	}

	protected void onDestroy() {
		super.onDestroy();
		Log.d("savedmediaactivity destroying", "destroying");
	}
}
